; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "DSHub"
!define PRODUCT_VERSION "Kappa RC1"
!define PRODUCT_PUBLISHER "Eugen Hristev"
!define PRODUCT_WEB_SITE "http://www.death-squad.ro/dshub"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\dshub.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "license.txt"
; Components page
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "DSHub"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\dshub.exe"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\readme.txt"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "Albanian"
!insertmacro MUI_LANGUAGE "Belarusian"
!insertmacro MUI_LANGUAGE "Bosnian"
!insertmacro MUI_LANGUAGE "Bulgarian"
!insertmacro MUI_LANGUAGE "Catalan"
!insertmacro MUI_LANGUAGE "Croatian"
!insertmacro MUI_LANGUAGE "Czech"
!insertmacro MUI_LANGUAGE "Danish"
!insertmacro MUI_LANGUAGE "Dutch"
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Finnish"
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Greek"
!insertmacro MUI_LANGUAGE "Hungarian"
!insertmacro MUI_LANGUAGE "Irish"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Japanese"
!insertmacro MUI_LANGUAGE "Latvian"
!insertmacro MUI_LANGUAGE "Macedonian"
!insertmacro MUI_LANGUAGE "Norwegian"
!insertmacro MUI_LANGUAGE "Polish"
!insertmacro MUI_LANGUAGE "Portuguese"
!insertmacro MUI_LANGUAGE "Romanian"
!insertmacro MUI_LANGUAGE "Russian"
!insertmacro MUI_LANGUAGE "Serbian"
!insertmacro MUI_LANGUAGE "Slovak"
!insertmacro MUI_LANGUAGE "Slovenian"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "Swedish"
!insertmacro MUI_LANGUAGE "Turkish"
!insertmacro MUI_LANGUAGE "Ukrainian"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "DSHub-Setup-xxx.exe"
InstallDir "$PROGRAMFILES\DSHub"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

Section "DSHub" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "changelog.txt"
  File "dshub.exe"
  File "DSHub.jar"
  File "LICENSE.jzlib.txt"
  File "LICENSE.slf4j.txt"
  File "license.txt"
  File "logo.jpg"
  File "mina-license.txt"
  File "readme.txt"
  File "NOTICE.txt"
  SetOutPath "$INSTDIR\lib"
  File "lib\AbsoluteLayout.jar"
  File "lib\log4j-1.2.14.jar"
  File "lib\log4j-over-slf4j-1.4.3.jar"
  File "lib\mina-core.jar"
  File "lib\mina-integration-jmx.jar"
  File "lib\slf4j-api-1.4.3.jar"
  File "lib\slf4j-log4j12-1.4.3.jar"
  File "lib\swing-layout-1.0.3.jar"
  File "lib\jython.jar"
  File "lib\bouncycastle.jar"
  
  

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\DSHub.lnk" "$INSTDIR\dshub.exe"
  CreateShortCut "$DESKTOP\DSHub.lnk" "$INSTDIR\dshub.exe"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\DSHub Readme.lnk" "$INSTDIR\readme.txt"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section "Additional Modules ( plugins ) and scripts" SEC02
  SetOutPath "$INSTDIR\modules"
  File "modules\Hubtracker.jar"
  File "modules\DSHubGenericModule.jar"
  File "modules\PingHH.jar"
  File "modules\Lookup.jar"
  File "modules\RSSFeed.jar"
  SetOutPath "$INSTDIR\scripts"
  SetOutPath "$INSTDIR\scripts\py"
  File "scripts\py\testscript.py"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  SetOutPath $INSTDIR
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\dshub.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\dshub.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

; Section descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "DSHub core and libraries"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "Additional useful modules ( plugins )"
!insertmacro MUI_FUNCTION_DESCRIPTION_END


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\modules\DSHubGenericModule.jar"
  Delete "$INSTDIR\modules\Hubtracker.jar"
  Delete "$INSTDIR\modules\PingHH.jar"
  Delete "$INSTDIR\modules\RSSFeed.jar"
  Delete "$INSTDIR\modules\Lookup.jar"
  Delete "$INSTDIR\lib\swing-layout-1.0.3.jar"
  Delete "$INSTDIR\lib\slf4j-log4j12-1.4.3.jar"
  Delete "$INSTDIR\lib\slf4j-api-1.4.3.jar"
  Delete "$INSTDIR\lib\mina-integration-jmx.jar"
  Delete "$INSTDIR\lib\jython.jar"
  Delete "$INSTDIR\lib\mina-core.jar"
  Delete "$INSTDIR\lib\log4j-over-slf4j-1.4.3.jar"
  Delete "$INSTDIR\lib\log4j-1.2.14.jar"
  Delete "$INSTDIR\lib\AbsoluteLayout.jar"
  Delete "$INSTDIR\lib\bouncycastle.jar"
  Delete "$INSTDIR\scripts\py\testscript.py"
  Delete "$INSTDIR\readme.txt"
  Delete "$INSTDIR\mina-license.txt"
  Delete "$INSTDIR\logo.jpg"
  Delete "$INSTDIR\license.txt"
  Delete "$INSTDIR\LICENSE.slf4j.txt"
  Delete "$INSTDIR\LICENSE.jzlib.txt"
  Delete "$INSTDIR\DSHub.jar"
  Delete "$INSTDIR\dshub.exe"
  Delete "$INSTDIR\changelog.txt"
  Delete "$INSTDIR\NOTICE.txt"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\DSHub Readme.lnk"
  Delete "$DESKTOP\DSHub.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\DSHub.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\modules"
  RMDir "$INSTDIR\lib"
  RMDir "$INSTDIR\scripts\py"
  RMDir "$INSTDIR\scripts"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd