package dshub;
/*
 * ADC.java
 *
 * Created on 04 martie 2007, 13:20
 *
 * DSHub ADC HubSoft
 * Copyright (C) 2007,2008  Eugen Hristev
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

import dshub.TigerImpl.Base32;

/**
 *This class is the main storage place for ADC command that hub has to send.
 *Also contains functions to modify strings from normal to ADC type and viceversa.
 *
 * @author Pietricica
 */
abstract public class ADC 
{
    
    
    /**First string to send to connecting client ;)*/
    public static final String Init="ISUP ADBASE ADTIGR ADUCM0 ADPING ADADC0"; //adding basic ucmds, adding tiger hash support, adding PING, adding basic ADCS
    
    /**  ISID = session id string for connecting client*/
    public  static final String ISID="ISID";
    
    /** The default motd.*/
    public static String MOTD=	"\n        DSHub 5.5 beta..\n"+
           "Some reminders :\n" +
           "DSHub is ADC software so you need an ADC compatibile client. More info about ADC on http://en.wikipedia.org/wiki/Advanced_Direct_Connect\n"+
"NMDC hublists dont work with ADC, only one exempt:\n"+
"  dchublist.org\n"+

	

           "Have a nice day !";
           
          
           public static String GreetingMsg=MOTD;
            
            ;
    public static String retNormStr(String blah)
    {
        
        return blah.replaceAll ("\\\\s"," ").replaceAll ("\\\\n","\n").replaceAll ("\\\\\\\\","\\\\")
                .replaceAll ("\\\\ ","\\\\s").replaceAll ("\\\\\\n","\\\\n");
    }
    public static String retADCStr(String blah)
    {
         return blah.replaceAll ("\\\\","\\\\\\\\").replaceAll (" ","\\\\s").replaceAll ("\n","\\\\n");
    }
    
    public static boolean isIP(String blah)
    {
        return blah.matches("\\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\b");
        
       
    }
    public static boolean isCID(String blah)
    {
        if(blah.length ()!=39)
            return false;
        try
        {
            Base32.decode (blah);
        }
        catch(IllegalArgumentException iae)
        {
            return false;
        }
        return true;
       
    }
    
    public static String getPingString()
    {
        return " HH"+Vars.Hub_Host+" UC"+SimpleHandler.getUserCount()+" SS"+
                     SimpleHandler.getTotalShare()+" SF"+SimpleHandler.getTotalFileCount()+
                     " MS"+1024*1024*Vars.min_share+" XS"+1024*1024*Vars.max_share+
                     " ML"+Vars.min_sl+ " XL"+Vars.max_sl+" XU"+Vars.max_hubs_user+
                     " XR"+Vars.max_hubs_reg+" XO"+Vars.max_hubs_op+
                     " MC"+Vars.max_users+" UP"+(System.currentTimeMillis()-Main.curtime);
    }
    
    
}